# Use a fixed version as latest tag doesn't exist
# https://hub.docker.com/r/docker/compose/tags
image:
  name: docker/compose:1.25.4
  entrypoint: ["sh", "-c"]

services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2

Build and Test:
  before_script:
    - apk add --update curl
  script:
    - docker-compose build
    - docker-compose up --detach
    - until [ $(docker-compose logs back-end | grep -c "Booting worker") -ge 1 ];
      do
        sleep 1;
        echo -n .;
      done;
      echo
    - until [ $(docker-compose logs db | grep -c "waiting for connections") -ge 2 ];
      do
        sleep 1;
        echo -n .;
      done;
      echo
    - curl -f http://docker:8080
    - >
      echo -n '{"favorite_colors": [{"color": "blue"}, {"color": "yellow"}]}' >
      expected
    - curl -f http://docker:8080/api/ > output
    - diff expected output
